import { TokenOwnerOffCurveError, getAssociatedTokenAddress, } from '@solana/spl-token';
import { ChainContext, } from '@wormhole-foundation/connect-sdk';
import { SolanaAddress } from './address';
export class SolanaChain extends ChainContext {
    async getTokenAccount(address, token) {
        const mint = token.toNative(this.chain).unwrap();
        const owner = new SolanaAddress(address).unwrap();
        try {
            const ata = await getAssociatedTokenAddress(mint, owner);
            return {
                chain: this.chain,
                address: new SolanaAddress(ata.toString()),
            };
        }
        catch (e) {
            if (e instanceof TokenOwnerOffCurveError) {
                // We were probably passed the ATA directly
                return { chain: this.chain, address };
            }
            throw e;
        }
    }
}
//# sourceMappingURL=chain.js.map